/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.sampletapestry.page;

import com.liferay.sampletapestry.bean.Book;
import com.liferay.sampletapestry.bean.BookList;

import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.event.PageBeginRenderListener;
import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.html.BasePage;

/**
 * @author Joseph Shum
 */
public abstract class AddBook
	extends BasePage implements PageBeginRenderListener {

	public abstract Book getBook();

	public abstract void setBook(Book book);

	public abstract BookList getBookList();

	public abstract void setBookList(BookList bookList);

	public abstract View getView();

	public abstract IEngineService getPageService();

	public void pageBeginRender(PageEvent event) {
		Book book = new Book();

		setBook(book);
	}

	public IPage doSubmit(IRequestCycle cycle) {
		View view = getView();

		Book book = getBook();

		BookList bookList = getBookList();

		bookList.addBook(book);

		view.setBooks(bookList.getBooks());

		return view;

	}

	public IPage doCancel(IRequestCycle cycle) {
		View view = getView();

		return view;
	}

}